--
--
-- contador crescente com enable, reset e carga paralela de 6 bits
-- Fernando Moraes
--
--
library IEEE; 
use IEEE.std_logic_1164.all; 
use IEEE.std_logic_unsigned.all;

Entity contup is
Port ( clock, reset,  Load, Enable:  In   std_logic;
		DATABUS :  In  Std_logic_Vector (5 downto 0);
		Upcount2 :  Out  Std_logic_Vector (5 downto 0));
End contup;

architecture RTL of contup is

Signal Upcount : std_logic_Vector (5 downto 0);

Begin
	Upcount2 <= Upcount;

	Upcounter : Process (clock, reset)    
	begin
	if reset = '1' then   
		Upcount <= "000000";
	elsif  clock'event and clock='1' then
			If ENABLE = '1' then

           		if LOAD = '1' then
					Upcount <= DATABUS;
				else
					Upcount <= Upcount + '1';   
				end if;
				
			end if; 
	end if; 
	end process Upcounter;

end RTL;



library IEEE; 
use IEEE.std_logic_1164.all; 
use IEEE.std_logic_unsigned.all;

    entity tb is
    end tb;
    
	architecture a2 of tb is
	
	component contup
    Port ( clock, reset,  Load, Enable:  In   std_logic;
		   DATABUS :  In  Std_logic_Vector (5 downto 0);
		   Upcount2 :  Out  Std_logic_Vector (5 downto 0));
	end component;
	
	signal ck, Load, Enable, reset : std_logic;
	signal DATABUS, Upcount2 : STD_LOGIC_VECTOR(5 downto 0) ;
	
	begin
	
	   cont1:  contup port map(clock=>ck, reset=>reset, load=>load, enable=>enable,
	                          databus=>databus, upcount2=>upcount2);
	   
	   reset <= '1', '0' after 10ns;
	   
	   load <= '1', '0' after 40ns, '1' after 200ns, '0' after 240ns, '1' after 300ns, '0' after 310 ns;
	   databus <= "110011",  "001100" after 150ns;
	   
	   enable <= '1', '0' after 200ns, '1' after 250ns;
	   	   
	   -- gerador de clock
	   process
	    begin
	     ck <= '1', '0' after 10ns;
	     wait for 20ns;
	   end process;
	    
	end a2;

